'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _freeport = require('freeport');

var _freeport2 = _interopRequireDefault(_freeport);

var _koa = require('koa');

var _koa2 = _interopRequireDefault(_koa);

var _opn = require('opn');

var _opn2 = _interopRequireDefault(_opn);

var _xtpl = require('xtpl');

var _xtpl2 = _interopRequireDefault(_xtpl);

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_CONFIG = {
  root: process.cwd(),
  host: 'localhost',
  demoDir: 'demo'
};

var HomePage = function () {
  function HomePage(cfg) {
    (0, _classCallCheck3.default)(this, HomePage);

    this._cfg = _lodash2.default.assign(DEFAULT_CONFIG, cfg || {});
    this._cfg.autoOpenBrowser = this._cfg.autoOpenBrowser === undefined ? true : this._cfg.autoOpenBrowser;
    this._pkg = require(_path2.default.join(this._cfg.root, 'package.json'));
    this._initServer();
  }

  (0, _createClass3.default)(HomePage, [{
    key: '_initServer',
    value: function _initServer() {
      var _this = this;

      this.app = new _koa2.default();

      var self = this;
      this.app.use(function () {
        var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx) {
          var pages, renderTpl;
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return self._findPages();

                case 2:
                  pages = _context.sent;
                  renderTpl = _this._cfg.template || _path2.default.join(__dirname, 'views', 'home.xtpl');
                  _context.next = 6;
                  return new _promise2.default(function (resolve, reject) {
                    _xtpl2.default.renderFile(renderTpl, {
                      pages: pages,
                      $config: self._cfg,
                      host: self._cfg.host,
                      name: self._pkg.name
                    }, function (err, body) {
                      if (err) {
                        return reject(err);
                      }

                      return resolve(body);
                    });
                  });

                case 6:
                  ctx.body = _context.sent;

                case 7:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this);
        }));

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
    }
  }, {
    key: 'start',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(port) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (port) {
                  _context2.next = 6;
                  break;
                }

                _context2.next = 3;
                return new _promise2.default(function (resolve, reject) {
                  (0, _freeport2.default)(function (err, port) {
                    if (err) {
                      return reject(err);
                    }

                    return resolve(port);
                  });
                });

              case 3:
                this._port = _context2.sent;
                _context2.next = 7;
                break;

              case 6:
                this._port = port;

              case 7:
                this.app.listen(this._port);
                if (this._cfg && this._cfg.autoOpenBrowser) {
                  this._open();
                }

              case 9:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function start(_x2) {
        return _ref2.apply(this, arguments);
      }

      return start;
    }()
  }, {
    key: '_findPages',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var demoRoot, files, pages;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                demoRoot = _path2.default.join(this._cfg.root, this._cfg.demoDir);
                files = _fs2.default.readdirSync(demoRoot);
                pages = [];


                files.forEach(function (file) {
                  var basename = _path2.default.basename(file);
                  var name = basename.replace(_path2.default.extname(basename), '');
                  if (file.endsWith('.xtpl') && _fs2.default.existsSync(_path2.default.join(demoRoot, name + '.json'))) {
                    pages.push(_path2.default.basename(file).replace('.xtpl', ''));
                  }
                });

                _logger2.default.debug('支持平台: ' + pages.join(' '));
                return _context3.abrupt('return', pages);

              case 6:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _findPages() {
        return _ref3.apply(this, arguments);
      }

      return _findPages;
    }()
  }, {
    key: '_open',
    value: function _open() {
      var url = 'http://127.0.0.1:' + this._port;
      (0, _opn2.default)(url);
      _logger2.default.info('\u6A21\u5757\u9884\u89C8\u5165\u53E3\uFF1A' + url);
    }
  }]);
  return HomePage;
}();

exports.default = HomePage;
module.exports = exports['default'];