'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _twhPreview = require('twh-preview');

var _twhPreview2 = _interopRequireDefault(_twhPreview);

var _co = require('co');

var _co2 = _interopRequireDefault(_co);

var _coEach = require('co-each');

var _coEach2 = _interopRequireDefault(_coEach);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _coWalk = require('co-walk');

var _coWalk2 = _interopRequireDefault(_coWalk);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _koa = require('koa');

var _koa2 = _interopRequireDefault(_koa);

var _koaStatic = require('koa-static');

var _koaStatic2 = _interopRequireDefault(_koaStatic);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var logger = require('./logger');

var DEFAULT_CONFIG = {
  root: process.cwd(),
  host: 'localhost',
  port: '3000',
  srcDir: 'src',
  demoDir: 'demo'
};

var Preview = function () {
  function Preview(cfg) {
    (0, _classCallCheck3.default)(this, Preview);

    this._cfg = _lodash2.default.assign(DEFAULT_CONFIG, cfg || {});
    this._pkg = require(_path2.default.join(this._cfg.root, 'package.json'));
    this._initServer();
  }

  (0, _createClass3.default)(Preview, [{
    key: '_initServer',
    value: function _initServer() {
      var _this = this;

      this._app = new _koa2.default();

      this._app.use((0, _koaStatic2.default)(_path2.default.join(this._cfg.root, this._cfg.demoDir)));

      this._app.use(function () {
        var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx, next) {
          var re, pagePath, params, ua, _ref2, headers, data;

          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!(ctx.path.indexOf('favicon.ico') >= 0)) {
                    _context.next = 4;
                    break;
                  }

                  _context.next = 3;
                  return next();

                case 3:
                  return _context.abrupt('return', _context.sent);

                case 4:
                  re = new RegExp('^/' + _this.getGroup() + '-' + _this._pkg.name);
                  pagePath = ctx.path.replace(/\/$/, '').replace(re, '').replace(/^\//, ''); // ugly

                  params = ctx.query;
                  ua = ctx.get('user-agent');
                  _context.next = 10;
                  return _this._preview(pagePath, params, ua);

                case 10:
                  _ref2 = _context.sent;
                  headers = _ref2.headers;
                  data = _ref2.data;

                  logger.debug((0, _stringify2.default)(headers));
                  logger.debug(data);
                  ctx.set(headers);
                  ctx.body = data;

                case 17:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this);
        }));

        return function (_x, _x2) {
          return _ref.apply(this, arguments);
        };
      }());
    }
  }, {
    key: 'listen',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(port) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this._app.listen(port || DEFAULT_CONFIG.port);

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function listen(_x3) {
        return _ref3.apply(this, arguments);
      }

      return listen;
    }()
  }, {
    key: '_preview',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(page, params, ua) {
        var pageJSON, type;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                pageJSON = this._loadPageJSON(page);

                if (pageJSON) {
                  _context3.next = 3;
                  break;
                }

                return _context3.abrupt('return', {
                  headers: {},
                  data: new Buffer(0)
                });

              case 3:
                pageJSON.page = {};
                (0, _keys2.default)(pageJSON).forEach(function (k) {
                  // 防止循环引用
                  if (k === 'page') return;
                  pageJSON.page[k] = pageJSON[k];
                });
                _context3.next = 7;
                return this._loadTemplates(page);

              case 7:
                pageJSON.page.templates = _context3.sent;

                pageJSON.data = this._loadMockData(pageJSON.data);
                pageJSON.previewPkgs = {};
                type = this._pkg && this._pkg.template && this._pkg.template.type || 'mod';

                if (!(type === 'solution')) {
                  _context3.next = 17;
                  break;
                }

                _context3.next = 14;
                return this._loadSolution();

              case 14:
                pageJSON.previewPkgs.solutions = _context3.sent;
                _context3.next = 20;
                break;

              case 17:
                _context3.next = 19;
                return this._loadModule();

              case 19:
                pageJSON.previewPkgs.modules = _context3.sent;

              case 20:
                pageJSON.env = 'dev';
                return _context3.abrupt('return', (0, _twhPreview2.default)(pageJSON, (0, _assign2.default)({ params: params, ua: ua }, this._cfg)));

              case 22:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _preview(_x4, _x5, _x6) {
        return _ref4.apply(this, arguments);
      }

      return _preview;
    }()
  }, {
    key: '_loadMockData',
    value: function _loadMockData(data) {
      var _this2 = this;

      var d = {};
      var pwd = _path2.default.join(this._cfg.root, this._cfg.demoDir);
      (0, _keys2.default)(data).forEach(function (k) {
        if ((0, _typeof3.default)(data[k]) === 'object') {
          d[k] = _this2._loadMockData(data[k]);
        } else {
          try {
            d[k] = JSON.parse(_fs2.default.readFileSync(_path2.default.join(pwd, data[k])));
          } catch (e) {
            d[k] = data[k];
            logger.warn('Load mock data failed: ' + data[k]);
          }
        }
      });
      return d;
    }
  }, {
    key: '_loadPageJSON',
    value: function _loadPageJSON(page) {
      var pwd = _path2.default.join(this._cfg.root, this._cfg.demoDir);
      var pageJSONPath = _path2.default.join(pwd, page + '.json');
      try {
        return JSON.parse(_fs2.default.readFileSync(pageJSONPath, 'utf8'));
      } catch (err) {
        if (err.message.includes('ENOENT')) {
          logger.error('file not found, message: ' + err.message);
        }
      }
    }
  }, {
    key: '_loadTemplates',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(page) {
        var _this3 = this;

        var pwd, templates, files;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                pwd = _path2.default.join(this._cfg.root, this._cfg.demoDir);
                templates = {};
                _context5.next = 4;
                return this._walk(pwd);

              case 4:
                files = _context5.sent;
                _context5.next = 7;
                return (0, _coEach2.default)(files, function () {
                  var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(file) {
                    var key;
                    return _regenerator2.default.wrap(function _callee4$(_context4) {
                      while (1) {
                        switch (_context4.prev = _context4.next) {
                          case 0:
                            key = file === page + '.xtpl' ? 'index.xtpl' : file;

                            templates[key] = _fs2.default.readFileSync(_path2.default.join(pwd, file), 'utf8');

                          case 2:
                          case 'end':
                            return _context4.stop();
                        }
                      }
                    }, _callee4, _this3);
                  }));

                  return function (_x8) {
                    return _ref6.apply(this, arguments);
                  };
                }());

              case 7:
                return _context5.abrupt('return', templates);

              case 8:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _loadTemplates(_x7) {
        return _ref5.apply(this, arguments);
      }

      return _loadTemplates;
    }()
  }, {
    key: 'getGroup',
    value: function getGroup() {
      if (this._pkg.name.includes('/')) {
        return this._pkg.name.slice(0, this._pkg.name.indexOf('/'));
      }
      var group = this._pkg.group;
      if (!group) {
        try {
          group = this._pkg.name.split('-')[0];
          if (group === 'zebra') {
            group = 'mui'; // ugly
          }
        } catch (err) {
          // ignore
        }
        group = group || 'pegasus';
      }
      return group;
    }
  }, {
    key: '_loadModule',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
        var pwd, files, group, mod;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                pwd = _path2.default.join(this._cfg.root, this._cfg.srcDir);
                _context6.next = 3;
                return this._walk(pwd);

              case 3:
                files = _context6.sent;
                group = this.getGroup();

                logger.debug('\u6A21\u5757 Group\uFF1A' + group);
                mod = {
                  type: 'module',
                  name: this._pkg.name.replace(/^@.+?\/(.+)$/g, function (match, p1) {
                    return p1;
                  }),
                  group: group,
                  version: this._pkg.version || '1.0.0',
                  templates: {}
                };
                _context6.next = 9;
                return (0, _coEach2.default)(files, function (file) {
                  mod.templates[file] = _fs2.default.readFileSync(_path2.default.join(pwd, file), 'utf8');
                });

              case 9:
                return _context6.abrupt('return', mod);

              case 10:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function _loadModule() {
        return _ref7.apply(this, arguments);
      }

      return _loadModule;
    }()
  }, {
    key: '_loadSolution',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7() {
        var pwd, files, mod;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                pwd = _path2.default.join(this._cfg.root, this._cfg.srcDir);
                _context7.next = 3;
                return this._walk(pwd);

              case 3:
                files = _context7.sent;
                mod = {
                  type: 'solution',
                  name: this._pkg.name.replace(/^@.+?\/(.+)$/g, function (match, p1) {
                    return p1;
                  }),
                  version: this._pkg.version || '1.0.0',
                  templates: {}
                };
                _context7.next = 7;
                return (0, _coEach2.default)(files, function (file) {
                  mod.templates[file] = _fs2.default.readFileSync(_path2.default.join(pwd, file), 'utf8');
                });

              case 7:
                return _context7.abrupt('return', mod);

              case 8:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function _loadSolution() {
        return _ref8.apply(this, arguments);
      }

      return _loadSolution;
    }()
  }, {
    key: '_walk',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(root) {
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                return _context9.abrupt('return', (0, _co2.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8() {
                  return _regenerator2.default.wrap(function _callee8$(_context8) {
                    while (1) {
                      switch (_context8.prev = _context8.next) {
                        case 0:
                          _context8.next = 2;
                          return (0, _coWalk2.default)(root);

                        case 2:
                          return _context8.abrupt('return', _context8.sent);

                        case 3:
                        case 'end':
                          return _context8.stop();
                      }
                    }
                  }, _callee8, this);
                })));

              case 1:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function _walk(_x9) {
        return _ref9.apply(this, arguments);
      }

      return _walk;
    }()
  }]);
  return Preview;
}();

exports.default = Preview;
module.exports = exports['default'];